#!/usr/bin/env node

// https://stackoverflow.com/a/64255382
const { promises: fs } = require('fs');
const path = require('path');

async function copyDir(src, dest) {
  await fs.mkdir(dest, { recursive: true });
  let entries = await fs.readdir(src, { withFileTypes: true });

  for (let entry of entries) {
    let srcPath = path.join(src, entry.name);
    let destPath = path.join(dest, entry.name);

    entry.isDirectory() ? await copyDir(srcPath, destPath) : await fs.copyFile(srcPath, destPath);
  }
}
const [, , target] = process.argv;

copyDir(path.resolve(__dirname, `../built-bundle`), target);
